Firework[] fs = new Firework[20];
boolean fired;

void setup(){
  background(#231942);
  frameRate(60);
  size(400,400);
  smooth();
  for (int i = 0; i < fs.length; i++){
    fs[i] = new Firework();
  }
}
void draw(){
  noStroke();
  fill(#231942,20);
  rect(0,0,width,height);
  strokeWeight(5);
   for (int i = 0; i < fs.length; i++){
      fs[i].draw();
    }
  saveFrame("Firework-####.png");
}
void mouseReleased(){
  fired = false;
  for (int i = 0; i < fs.length; i++){
    if((fs[i].hidden)&&(!fired)){
      fs[i].launch();
      fired = true;
    }
  }
}

class Dot {
  float hue;

  float R = random(10, 100);
  float theta = random(TWO_PI);

  float x;
  float y;

  float goal_x = R * cos(theta);
  float goal_y = R * sin(theta);

  float easing_x = random(0.03, 0.07);
  float easing_y = random(0.03, 0.07);

  float sat = random(30,200);
  float brt = random(30,100); 

  Dot(float tmpHue) {
    x = 0;
    y = 0;
    hue = tmpHue;
  }

  void move() {
    x += (goal_x - x) * easing_x;
    y += (goal_y - y) * easing_y;
  }

  void display(float alp) {
    stroke(hue, sat, brt, alp);
    strokeWeight(5);
    point(x, y);
  }
}

class Explosion {
  int dot_val = (int)random(100, 200);

  Dot[] dots = new Dot[dot_val];

  float x = 0;
  float y = 0;
  float hue = random(360);

  float alp = random(10, 255);
  float alp_spd = random(3, 6);

  Explosion() {
    for (int i = 0; i < dots.length;i++) {
      dots[i] = new Dot(hue);
    }
  }

  void display() {
    pushMatrix();
    translate(x, y);
    for (int i = 0; i < dots.length;i++) {
      dots[i].move();
      dots[i].display(alp);
    }
    
    alp -= alp_spd;
    
    if (alp < 0) {
      x = random(width);
      y = random(height);
      hue = random(360);

      for (int i = 0; i < dots.length;i++) {
        dots[i].x = 0;
        dots[i].y = 0;
      }
      alp = 255;
    }

    popMatrix(); 
  }
}

class Firework{
  float x, y, oldX,oldY, ySpeed, targetX, targetY, explodeTimer;
  int duration;
  boolean launched,exploded,hidden;
  Explosion flower = new Explosion();
  Firework(){
    launched = false;
    exploded = false;
    hidden = true;
  }
  void draw(){
    if((launched)&&(!exploded)&&(!hidden)){
      launchMaths();
      strokeWeight(1);
      stroke(255);
      line(x,y,oldX,oldY);
    }
    if((!launched)&&(exploded)&&(!hidden)){
      explodeMaths();
      flower.x = x;
      flower.y = y;
      flower.display();

    }
  }
  void launch(){
    x = oldX = mouseX;
    y = oldY = height;
    targetX = mouseX;
    targetY = mouseY;
    ySpeed = random(3,7);
    duration = ceil(random(4))*30 + 30;
    launched = true;
    exploded = false;
    hidden = false;
  }
  void launchMaths(){
    oldX = x;
    oldY = y;
    if(dist(x,y,targetX,targetY) > 6){
      x += (targetX - x)/2;
      y += -ySpeed;
    }else{
      explode();
    }
  }
  void explode(){
    explodeTimer = 0;
    launched = false;
    exploded = true;
    hidden = false;
  }
  void explodeMaths(){
    if(explodeTimer < duration){
      explodeTimer+= 0.3;
    }else{
      hide();
    }
  }
  void hide(){
    launched = false;
    exploded = false;
    hidden = true;
  }
}